;=========================================================
;Code for DirectDraw (direct, non-GDI) surface drawing
;=========================================================
;edi = DDSurface interface for back buffer

DirectDrawMain:
cmp [Effects_BOOL],0
    jnz DoDirectDrawMain
    ret
DoDirectDrawMain:

push ebp
mov ebp,esp
sub esp,DDSURFACEDESC2+20

	mov eax,[BaseDDSurfaceADDR]
	mov ecx,[eax]
	mov edi,[ecx+4Ch]		     ;edi = DDSurface object
	push lpDDBltFx
	push DDBLT_COLORFILL+DDBLT_WAIT      ;+DDBLT_ROP
	mov eax,[edi]
	push 0
	mov [lpDDBltFx.dwFillColor],0A0A0h
	push 0
	;mov [lpDDBltFx.dwROP],SRCCOPY
	push 0
	push edi
	call DWORD [eax+DirectDrawSurface.Blt]

mov esp,ebp
pop ebp
ret



	mov eax,[BaseDDSurfaceADDR]
	mov ecx,[eax]
	mov edi,[ecx+4Ch]		;edi = DDSurface object
	mov eax,[edi]
	lea edx,[ebp-DDSURFACEDESC2]
	push 0
	mov DWORD [edx],DDSURFACEDESC2	   ;(size)
	push DDLOCK_WRITEONLY+DDLOCK_READONLY+DDLOCK_WAIT
	push edx			   ;surface description
	push 0
	push edi
	call DWORD [eax+DirectDrawSurface.Lock]
	test eax,eax
	     jnz DDrawLockError

	mov ebx,[Effects_BOOL]
	    test ebx,1
	    jz NoScreenFlash
	       lea ecx,[ebp-DDSURFACEDESC2]
	       call ScreenFlash
	    NoScreenFlash:

	push 0
	mov eax,[edi]
	push edi
	call DWORD [eax+DirectDrawSurface.Unlock]

	DDrawLockError:
mov esp,ebp
pop ebp
ret

;=========================================================
flash_and_value dq	0FFFFFFFFFFFFFFFFh

ScreenFlash:	;ecx=DDSURFACEDESC2 struc for current surface
push esi
push edi
push ebx
push ebp
mov ebx,ecx
	;movq mm1,[flash_and_value]
	mov edi,[ebx+DDSURFACEDESC2.lpSurface]
	mov edx,[ebx+DDSURFACEDESC2.dwHeight]
	mov eax,[ebx+DDSURFACEDESC2.dwWidth]
	mov esi,eax
	shr esi,2	;width*2 = bytes, bytes/8=qwords    1 for DWORD, 2 for QWORD
	mov ebp,[ebx+DDSURFACEDESC2.lPitch]
	shl eax,1
	sub ebp,eax

	HeightLoopScreenFlash:

		mov ecx,esi
		WidthLoopScreenFlash:
	       ; movq mm0,QWORD [edi]
	       ; pandn mm0,mm1
	       ; movq QWORD [edi],mm0
		add edi,8
		loop WidthLoopScreenFlash

	add edi,ebp
	sub edx,1
	    jnb HeightLoopScreenFlash

;emms
pop ebp
pop ebx
pop edi
pop esi
ret
;=========================================================
