;============================================================
;code run before every frame is drawn for LOC-MAP cheats
;============================================================

LOC_MAP_NEW_TEST_CODE:		;called before every frame flip

	push esi
	push edi
	push edx
	push ecx
	push ebx
	push eax

	call TestForFlyModeKeys
	call DirectDrawMain

	call SHOWMAP_CODE

	call SetNewTimeStamp
	call DisplayDinoInfoMain
	call DisplayDrawDistance
	call DisplayNewKeysState
	call DisplayPlayerFaceFloats
	call DisplayErrorCount

	or [IsInGame_BOOL],1

	pop eax
	pop ebx
	pop ecx
	pop edx
	pop edi
	pop esi

cmp [USE_LOC],1
jz USE_LOC_IN_EXE_CODE
	add esp,4		;get rid of return address from call
	jmp [NO_LOC_JUMP_ADDR]	;jump if LOC disabled
USE_LOC_IN_EXE_CODE:

ret				;if LOC cheat enable, just continue




